import React, {
  useState,
  useEffect,
  useMemo,
  useRef
} from 'react';
import ReactDropdown from 'react-dropdown';
import { select } from 'd3';
import { config } from './config';
import { useData } from './hooks/useData';
import { useGenres } from './hooks/useGenres';
import Table from './Table';


const App = () => {
  const {
    width,
    height,
    dataUrl,
    genresUrl
  } = config;

  const { columns, data } = useData(dataUrl);
  const { genres } = useGenres(genresUrl);

  if (data.length === 0 || genres.length === 0) {
    return <pre>Loading...</pre>;
  }
  
  return (
    <>
      <div className="container">
        <Table data={data} columns={columns} />
      </div>
    </>
  );
};

export default App;
