import { useEffect, useCallback } from 'react';
import { select } from 'd3';

const Table = ({data, columns}) => {
  const col = useCallback((d) => {
    console.log(d);
    return d;
  }, []);
  const row = useCallback((d) => {
    console.log(d);
    return d;
  }, []);
  
  useEffect(() => {
    
    const table = select('.container')
    	.append('table')
                .style("border-collapse", "collapse")
                .style("border", "1px black solid");
    
    table.append("thead").append("tr")
      .selectAll("th")
      .data(columns)
      .enter().append("th")
      .text(function(d) { return d; })
      .attr('class', 'row')
      .style("border", "1px black solid")
      .style("padding", "5px")
      .style("background-color", "lightgray")
      .style("font-weight", "bold")
      .style("text-transform", "uppercase");

    table.append("tbody")
      .selectAll("tr").data(data)
      .enter().append("tr")
      .on("mouseover", function(){
      	select(this).classed('hoveredRow', true);
    	})
      .on("mouseout", function(){
        select(this).classed('hoveredRow', false);
      })
      .selectAll("td")
      .data(d => d)
      .enter().append("td")
      .style("border", "1px black solid")
      .style("padding", "5px")
      .text(function(d){return d;})
      .style("font-size", "12px");
    
    
    return () => { 
      table.append("tbody")
        .selectAll("tr").data(data)
        .enter().append("tr")
        .on('mouseover', null)
        .on('mouseout', null);
    };
    
  },[]);
  
  return null;
}

export default Table;