import { useState, useEffect, useCallback } from "react";
import { csv } from "d3";

export const useData = (url) => {
  const [data, setData] = useState([]);
  const [columns, setColumns] = useState([]);
  
  const tableData = new Array();
  const all = useCallback((all) => {
  	all.forEach(d => {
      tableData.push(row(d));
    });
    
    return tableData;
  }, []);
  const row = useCallback((obj) => {
		const arr = new Array();
    for (const [key, value] of Object.entries(obj)) {
      arr.push(value);
    }
    
    return arr;
  }, []);
  
  useEffect(() => {    
    csv(url).then(allTheData => {
      const stuff = all(allTheData);
      setColumns(allTheData.columns);
      setData(stuff);
    });      
  }, [url]);
  
  return {data, columns};
};
