import { useState, useEffect, useCallback } from 'react';
import { csv, timeParse } from 'd3';

export const useGenres = (url) => {
  const [genres, setGenres] = useState([]);
  
  const transform = useCallback((data,column) => {
    const arr = new Array();
  	data.forEach(d => {
      arr.push(d[column]);
    });
    
    return arr;
  }, []);
  
  useEffect(() => {
    csv(url).then(data => {
      setGenres(transform(data, data.columns[0]));
    });
  }, []);
  
  return {genres};
}